﻿var __extends = this.__extends || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    __.prototype = b.prototype;
    d.prototype = new __();
};
define(["require", "exports", "commands/commandBase"], function(require, exports, commandBase) {
    var deleteDocsMatchingQueryCommand = (function (_super) {
        __extends(deleteDocsMatchingQueryCommand, _super);
        function deleteDocsMatchingQueryCommand(indexName, queryText, db) {
            _super.call(this);
            this.indexName = indexName;
            this.queryText = queryText;
            this.db = db;
        }
        deleteDocsMatchingQueryCommand.prototype.execute = function () {
            var _this = this;
            this.reportInfo("Deleting docs matching query...");

            var args = {
                query: this.queryText,
                pageSize: 128,
                allowStale: false
            };

            var url = "/bulk_docs/" + this.indexName + this.urlEncodeArgs(args);
            var task = this.del(url, null, this.db);
            task.done(function () {
                return _this.reportSuccess("Docs deleted");
            });
            task.fail(function (response) {
                return _this.reportError("Error deleting docs matching query", response.responseText, response.statusText);
            });

            return task;
        };
        return deleteDocsMatchingQueryCommand;
    })(commandBase);

    
    return deleteDocsMatchingQueryCommand;
});
