﻿var __extends = this.__extends || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    __.prototype = b.prototype;
    d.prototype = new __();
};
define(["require", "exports", "commands/commandBase"], function(require, exports, commandBase) {
    var createFilesystemCommand = (function (_super) {
        __extends(createFilesystemCommand, _super);
        function createFilesystemCommand(filesystemName, filesystemPath) {
            _super.call(this);
            this.filesystemName = filesystemName;
            this.filesystemPath = filesystemPath;

            if (!filesystemName) {
                this.reportError("File System must have a name!");
                throw new Error("File System must have a name!");
            }

            if (this.filesystemPath == null) {
                this.filesystemPath = "~\\Filesystems\\" + this.filesystemName;
            }
        }
        createFilesystemCommand.prototype.execute = function () {
            var _this = this;
            this.reportInfo("Creating File System '" + this.filesystemName + "'");

            var filesystemDoc = {
                "Settings": { "Raven/FileSystem/DataDir": this.filesystemPath },
                "Disabled": false
            };

            var url = "/ravenfs/admin/" + this.filesystemName;
            var createTask = this.put(url, JSON.stringify(filesystemDoc), null, { dataType: undefined });
            createTask.done(function () {
                return _this.reportSuccess(_this.filesystemName + " created");
            });
            createTask.fail(function (response) {
                return _this.reportError("Failed to create file system", response.responseText, response.statusText);
            });

            return createTask;
        };
        return createFilesystemCommand;
    })(commandBase);

    
    return createFilesystemCommand;
});
