﻿var __extends = this.__extends || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    __.prototype = b.prototype;
    d.prototype = new __();
};
define(["require", "exports", "commands/commandBase", "models/filesystem/file", "common/pagedResultSet"], function(require, exports, commandBase, file, pagedResultSet) {
    var getFilesystemFilesCommand = (function (_super) {
        __extends(getFilesystemFilesCommand, _super);
        function getFilesystemFilesCommand(fs, skip, take) {
            _super.call(this);
            this.fs = fs;
            this.skip = skip;
            this.take = take;
        }
        getFilesystemFilesCommand.prototype.execute = function () {
            var filesTask = this.fetchFiles();
            var totalResultsTask = this.fetchTotalResultCount();

            var doneTask = $.Deferred();
            var combinedTask = $.when(filesTask, totalResultsTask);

            combinedTask.done(function (filesResult, resultsCount) {
                doneTask.resolve(new pagedResultSet(filesResult, resultsCount));
            });
            combinedTask.fail(function (xhr) {
                return doneTask.reject(xhr);
            });

            return doneTask;
        };

        getFilesystemFilesCommand.prototype.fetchFiles = function () {
            var args = {
                start: this.skip,
                pageSize: this.take
            };

            var url = "/files";
            var filesSelector = function (files) {
                return files.map(function (d) {
                    return new file(d);
                });
            };
            var task = this.query(url, args, this.fs, filesSelector);

            return task;
        };

        getFilesystemFilesCommand.prototype.fetchTotalResultCount = function () {
            var url = "/stats";
            var countSelector = function (dto) {
                return dto.FileCount;
            };
            return this.query(url, null, this.fs, countSelector);
        };
        return getFilesystemFilesCommand;
    })(commandBase);

    
    return getFilesystemFilesCommand;
});
