﻿var __extends = this.__extends || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    __.prototype = b.prototype;
    d.prototype = new __();
};
define(["require", "exports", "commands/commandBase", "models/filesystem/synchronizationDetails"], function(require, exports, commandBase, synchronizationDetails) {
    var getSyncOutgoingActivitiesCommand = (function (_super) {
        __extends(getSyncOutgoingActivitiesCommand, _super);
        function getSyncOutgoingActivitiesCommand(fs) {
            _super.call(this);
            this.fs = fs;
        }
        getSyncOutgoingActivitiesCommand.prototype.execute = function () {
            var pendingUrl = "/synchronization/pending";
            var activeUrl = "/synchronization/active";

            var pendingTask = this.query(pendingUrl, null, this.fs);
            var activeTask = this.query(activeUrl, null, this.fs);

            var doneTask = $.Deferred();

            var combinedTask = $.when(pendingTask, activeTask);
            combinedTask.done(function (pendingList, activeList) {
                doneTask.resolve(synchronizationDetails.fromOutgoingActivities(pendingList.Items, activeList.Items));
            });
            combinedTask.fail(function (xhr) {
                return doneTask.reject(xhr);
            });

            return doneTask;
        };
        return getSyncOutgoingActivitiesCommand;
    })(commandBase);

    
    return getSyncOutgoingActivitiesCommand;
});
