var __extends = this.__extends || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    __.prototype = b.prototype;
    d.prototype = new __();
};
define(["require", "exports", "commands/commandBase", "models/collection"], function(require, exports, commandBase, collection) {
    var getCollectionsCommand = (function (_super) {
        __extends(getCollectionsCommand, _super);
        function getCollectionsCommand(ownerDb) {
            _super.call(this);
            this.ownerDb = ownerDb;

            if (!this.ownerDb) {
                throw new Error("Must specify a database.");
            }
        }
        getCollectionsCommand.prototype.execute = function () {
            var _this = this;
            var args = {
                field: "Tag",
                fromValue: "",
                pageSize: 128
            };

            var resultsSelector = function (collectionNames) {
                return collectionNames.map(function (n) {
                    return new collection(n, _this.ownerDb);
                });
            };
            return this.query("/terms/Raven/DocumentsByEntityName", args, this.ownerDb, resultsSelector).fail(function () {
                return _this.reportError("Raven/DocumentsByEntityName index not found", "In order to enjoy the studio interface, please recreate the index: \n" + "index definition: \n" + 'Name: Raven/DocumentsByEntityName \n' + 'Map: from doc in docs let Tag = doc["@metadata"]["Raven-Entity-Name"] select new { Tag, LastModified = (DateTime)doc["@metadata"]["Last-Modified"] };');
            });
        };
        return getCollectionsCommand;
    })(commandBase);

    
    return getCollectionsCommand;
});
