var __extends = this.__extends || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    __.prototype = b.prototype;
    d.prototype = new __();
};
define(["require", "exports", "common/pagedResultSet", "commands/commandBase", "models/conflictsInfo"], function(require, exports, pagedResultSet, commandBase, conflictsInfo) {
    var getConflictsCommand = (function (_super) {
        __extends(getConflictsCommand, _super);
        function getConflictsCommand(ownerDb, skip, take) {
            _super.call(this);
            this.ownerDb = ownerDb;
            this.skip = skip;
            this.take = take;

            if (!this.ownerDb) {
                throw new Error("Must specify a database.");
            }
        }
        getConflictsCommand.prototype.execute = function () {
            var args = {
                sort: "-ConflictDetected",
                start: this.skip,
                pageSize: this.take,
                skipTransformResults: true,
                resultsTransformer: "Raven/ConflictDocumentsTransformer"
            };

            var resultsSelector = function (dto) {
                return new conflictsInfo(dto);
            };
            var url = "/indexes/Raven/ConflictDocuments";
            var conflictsTask = $.Deferred();
            this.query(url, args, this.ownerDb, resultsSelector).fail(function (response) {
                return conflictsTask.reject(response);
            }).done(function (conflicts) {
                var items = conflicts.results;
                var resultsSet = new pagedResultSet(items, conflicts.totalResults);
                conflictsTask.resolve(resultsSet);
            });

            return conflictsTask;
        };
        return getConflictsCommand;
    })(commandBase);

    
    return getConflictsCommand;
});
