var __extends = this.__extends || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    __.prototype = b.prototype;
    d.prototype = new __();
};
define(["require", "exports", "commands/commandBase", "models/document", "common/pagedResultSet"], function(require, exports, commandBase, document, pagedResultSet) {
    var queryIndexCommand = (function (_super) {
        __extends(queryIndexCommand, _super);
        function queryIndexCommand(indexName, db, skip, take, queryText, sorts, transformerName, showFields, indexEntries, useAndOperator) {
            _super.call(this);
            this.indexName = indexName;
            this.db = db;
            this.skip = skip;
            this.take = take;
            this.queryText = queryText;
            this.sorts = sorts;
            this.transformerName = transformerName;
            this.showFields = showFields;
            this.indexEntries = indexEntries;
            this.useAndOperator = useAndOperator;
        }
        queryIndexCommand.prototype.execute = function () {
            var _this = this;
            var selector = function (results) {
                return new pagedResultSet(results.Results.map(function (d) {
                    return new document(d);
                }), results.TotalResults, results);
            };
            var queryTask = this.query(this.getUrl(), null, this.db, selector);
            queryTask.fail(function (response) {
                return _this.reportError("Error querying index", response.responseText, response.statusText);
            });

            return queryTask;
        };

        queryIndexCommand.prototype.getUrl = function () {
            var url = "/indexes/" + this.indexName;
            var resultsTransformerUrlFragment = this.transformerName ? "&resultsTransformer=" + this.transformerName : "";
            var urlArgs = this.urlEncodeArgs({
                query: this.queryText ? this.queryText : undefined,
                start: this.skip,
                pageSize: this.take,
                sort: this.sorts.map(function (s) {
                    return s.toQuerySortString();
                }),
                skipTransformResults: true,
                fetch: this.showFields ? "__all_fields" : undefined,
                debug: this.indexEntries ? "entries" : undefined,
                operator: this.useAndOperator ? "AND" : undefined
            }) + resultsTransformerUrlFragment;

            return url + urlArgs;
        };
        return queryIndexCommand;
    })(commandBase);

    
    return queryIndexCommand;
});
