var __extends = this.__extends || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    __.prototype = b.prototype;
    d.prototype = new __();
};
define(["require", "exports", "commands/commandBase"], function(require, exports, commandBase) {
    var saveDocumentCommand = (function (_super) {
        __extends(saveDocumentCommand, _super);
        function saveDocumentCommand(id, document, db, reportSaveProgress) {
            if (typeof reportSaveProgress === "undefined") { reportSaveProgress = true; }
            _super.call(this);
            this.id = id;
            this.document = document;
            this.db = db;
            this.reportSaveProgress = reportSaveProgress;
        }
        saveDocumentCommand.prototype.execute = function () {
            var _this = this;
            if (this.reportSaveProgress) {
                this.reportInfo("Saving " + this.id + "...");
            }

            var customHeaders = {
                'Raven-Client-Version': commandBase.ravenClientVersion,
                'If-None-Match': this.document.__metadata.etag
            };

            var metadata = this.document.__metadata.toDto();

            for (var key in metadata) {
                if (key.indexOf('@') !== 0)
                    customHeaders[key] = metadata[key];
            }

            var jQueryOptions = {
                headers: customHeaders
            };
            var args = JSON.stringify(this.document.toDto());
            var url = "/docs/" + this.id;
            var saveTask = this.put(url, args, this.db, jQueryOptions);

            if (this.reportSaveProgress) {
                saveTask.done(function () {
                    return _this.reportSuccess("Saved " + _this.id);
                });
                saveTask.fail(function (response) {
                    return _this.reportError("Failed to save " + _this.id, response.responseText, response.statusText);
                });
            }
            return saveTask;
        };
        return saveDocumentCommand;
    })(commandBase);

    
    return saveDocumentCommand;
});
