var __extends = this.__extends || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    __.prototype = b.prototype;
    d.prototype = new __();
};
define(["require", "exports", "commands/commandBase"], function(require, exports, commandBase) {
    var saveIndexAsPersistentCommand = (function (_super) {
        __extends(saveIndexAsPersistentCommand, _super);
        function saveIndexAsPersistentCommand(indexToPersist, db) {
            _super.call(this);
            this.indexToPersist = indexToPersist;
            this.db = db;
        }
        saveIndexAsPersistentCommand.prototype.execute = function () {
            var _this = this;
            this.reportInfo("Persisting " + this.indexToPersist.name + "...");

            var url = "/indexes/" + this.indexToPersist.name + "?op=forceWriteToDisk";
            var saveTask = this.post(url, null, this.db);
            saveTask.done(function () {
                _this.reportSuccess("Persisted " + _this.indexToPersist.name);
                _this.indexToPersist.isOnRam("false");
            });
            saveTask.fail(function (response) {
                return _this.reportError("Failed to persist " + _this.indexToPersist.name, response.responseText, response.statusText);
            });

            return saveTask;
        };
        return saveIndexAsPersistentCommand;
    })(commandBase);

    
    return saveIndexAsPersistentCommand;
});
