var __extends = this.__extends || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    __.prototype = b.prototype;
    d.prototype = new __();
};
define(["require", "exports", "commands/commandBase", "models/index"], function(require, exports, commandBase, index) {
    var saveIndexDefinitionCommand = (function (_super) {
        __extends(saveIndexDefinitionCommand, _super);
        function saveIndexDefinitionCommand(index, priority, db) {
            _super.call(this);
            this.index = index;
            this.priority = priority;
            this.db = db;
        }
        saveIndexDefinitionCommand.prototype.execute = function () {
            var _this = this;
            this.reportInfo("Saving " + this.index.Name + "...");

            var result = $.Deferred();
            var runSavePriority = function () {
                return _this.savePriority().fail(function (response) {
                    _this.reportWarning("Index was saved, but failed to set its priority.", response.responseText, response.statusText);
                    result.reject(response);
                }).done(function () {
                    _this.reportSuccess("Saved " + _this.index.Name + ".");
                    result.resolve();
                });
            };

            this.saveDefinition().fail(function (response) {
                _this.reportError("Failed to save " + _this.index.Name, response.responseText, response.statusText);
                result.reject(response);
            }).done(function () {
                return runSavePriority();
            });

            return result;
        };

        saveIndexDefinitionCommand.prototype.savePriority = function () {
            var url = "/indexes/set-priority/" + this.index.Name + "?priority=" + index.priorityToString(this.priority);
            return this.post(url, null, this.db, { dataType: undefined });
        };

        saveIndexDefinitionCommand.prototype.saveDefinition = function () {
            var urlArgs = {
                definition: "yes"
            };
            var putArgs = JSON.stringify(this.index);
            var url = "/indexes/" + this.index.Name + this.urlEncodeArgs(urlArgs);
            return this.put(url, putArgs, this.db);
        };
        return saveIndexDefinitionCommand;
    })(commandBase);

    
    return saveIndexDefinitionCommand;
});
