var __extends = this.__extends || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    __.prototype = b.prototype;
    d.prototype = new __();
};
define(["require", "exports", "commands/commandBase"], function(require, exports, commandBase) {
    var saveIndexLockModeCommand = (function (_super) {
        __extends(saveIndexLockModeCommand, _super);
        function saveIndexLockModeCommand(index, lockMode, db) {
            _super.call(this);
            this.index = index;
            this.lockMode = lockMode;
            this.db = db;
        }
        saveIndexLockModeCommand.prototype.execute = function () {
            var _this = this;
            this.reportInfo("Saving " + this.index.name + "...");
            var args = {
                op: "lockModeChange",
                mode: this.lockMode
            };

            var url = "/indexes/" + this.index.name + this.urlEncodeArgs(args);
            var saveTask = this.post(url, JSON.stringify(args), this.db, { dataType: 'text' });
            saveTask.done(function () {
                debugger;
                _this.reportSuccess("Saved " + _this.index.name);
            });
            saveTask.fail(function (response) {
                debugger;
                _this.reportError("Failed to save this" + _this.index.name, response.responseText);
            });

            return saveTask;
        };
        return saveIndexLockModeCommand;
    })(commandBase);

    
    return saveIndexLockModeCommand;
});
