var __extends = this.__extends || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    __.prototype = b.prototype;
    d.prototype = new __();
};
define(["require", "exports", "commands/commandBase"], function(require, exports, commandBase) {
    var savePeriodicBackupSetupCommand = (function (_super) {
        __extends(savePeriodicBackupSetupCommand, _super);
        function savePeriodicBackupSetupCommand(setupToPersist, db) {
            _super.call(this);
            this.setupToPersist = setupToPersist;
            this.db = db;
        }
        savePeriodicBackupSetupCommand.prototype.execute = function () {
            var _this = this;
            this.reportInfo("Saving Periodic Backup setup.");
            return jQuery.when(this.saveAccountInformation(), this.saveSetup()).done(function () {
                return _this.reportSuccess("Saved Periodic Backup setup.");
            }).fail(function (response) {
                return _this.reportError("Failed to save Periodic Backup setup.", response.responseText);
            });
        };

        savePeriodicBackupSetupCommand.prototype.saveAccountInformation = function () {
            var url = "/admin/databases/" + this.db.name;
            var putArgs = JSON.stringify(this.setupToPersist.toDatabaseSettingsDto());
            return this.post(url, putArgs, null, { dataType: undefined });
        };

        savePeriodicBackupSetupCommand.prototype.saveSetup = function () {
            var url = "/docs/Raven/Backup/Periodic/Setup";
            var putArgs = JSON.stringify(this.setupToPersist.toDto());
            return this.put(url, putArgs, this.db);
        };
        return savePeriodicBackupSetupCommand;
    })(commandBase);
    
    return savePeriodicBackupSetupCommand;
});
