﻿var __extends = this.__extends || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    __.prototype = b.prototype;
    d.prototype = new __();
};
define(["require", "exports", "commands/commandBase", "commands/getSingleTransformerCommand", "models/transformer"], function(require, exports, commandBase, getSingleTransformerCommand, transformer) {
    var saveTransformerCommand = (function (_super) {
        __extends(saveTransformerCommand, _super);
        function saveTransformerCommand(trans, db) {
            _super.call(this);
            this.trans = trans;
            this.db = db;
        }
        saveTransformerCommand.prototype.execute = function () {
            var _this = this;
            var doneTask = $.Deferred();

            var saveTransformerUrl = "/transformers/" + this.trans.name();
            var saveTransformerPutArgs = JSON.stringify(this.trans.toSaveDto());

            this.put(saveTransformerUrl, saveTransformerPutArgs, this.db).fail(function (result) {
                _this.reportError("Unable to save transformer", result.responseText, result.statusText);
                doneTask.reject(result);
            }).done(function (result) {
                doneTask.resolve();
                new getSingleTransformerCommand(result.Transformer, _this.db).execute().fail(function (xhr) {
                    return doneTask.reject(xhr);
                }).done(function (savedTransformer) {
                    _this.reportInfo("Saved " + _this.trans.name());
                    doneTask.resolve(new transformer().initFromSave(savedTransformer));
                });
            });

            return doneTask;
        };
        return saveTransformerCommand;
    })(commandBase);

    
    return saveTransformerCommand;
});
