define(["require", "exports"], function(require, exports) {
    var luceneField = (function () {
        function luceneField(name, stores, indexing, sort, analyzer, suggestionDistance, suggestionAccuracy, termVector) {
            if (typeof stores === "undefined") { stores = "No"; }
            if (typeof indexing === "undefined") { indexing = "Default"; }
            if (typeof sort === "undefined") { sort = "None"; }
            if (typeof analyzer === "undefined") { analyzer = null; }
            if (typeof suggestionDistance === "undefined") { suggestionDistance = "None"; }
            if (typeof suggestionAccuracy === "undefined") { suggestionAccuracy = 0.5; }
            if (typeof termVector === "undefined") { termVector = "No"; }
            this.name = ko.observable();
            this.stores = ko.observable();
            this.indexing = ko.observable();
            this.sort = ko.observable();
            this.analyzer = ko.observable();
            this.suggestionDistance = ko.observable();
            this.suggestionAccuracy = ko.observable();
            this.termVector = ko.observable();
            this.name(name);
            this.stores(stores);
            this.indexing(indexing);
            this.sort(sort);
            this.analyzer(analyzer);
            this.suggestionAccuracy(suggestionAccuracy);
            this.suggestionDistance(suggestionDistance);
            this.termVector(termVector);
        }
        luceneField.prototype.toSuggestionDto = function () {
            return {
                Distance: this.suggestionDistance(),
                Accuracy: this.suggestionAccuracy()
            };
        };
        return luceneField;
    })();

    
    return luceneField;
});
