define(["require", "exports"], function(require, exports) {
    var replicationConfig = (function () {
        function replicationConfig(dto) {
            this.documentConflictResolution = ko.observable().extend({ required: true });
            this.attachmentConflictResolution = ko.observable().extend({ required: true });
            this.documentConflictResolution(dto.DocumentConflictResolution);
            this.attachmentConflictResolution(dto.AttachmentConflictResolution);
        }
        replicationConfig.prototype.toDto = function () {
            return {
                DocumentConflictResolution: this.documentConflictResolution(),
                AttachmentConflictResolution: this.attachmentConflictResolution()
            };
        };

        replicationConfig.prototype.resolveDocumentsConflictsToLocal = function () {
            this.documentConflictResolution(replicationConfig.RESOLVE_TO_LOCAL);
        };

        replicationConfig.prototype.resolveDocumentsConflictsToRemote = function () {
            this.documentConflictResolution(replicationConfig.RESOLVE_TO_REMOTE);
        };

        replicationConfig.prototype.doNotResolveDocumentsConflictsAutomatically = function () {
            this.documentConflictResolution(replicationConfig.DO_NOT_RESOLVE_AUTOMATICALLY);
        };

        replicationConfig.prototype.resolveAttachmentsConflictsToLocal = function () {
            this.attachmentConflictResolution(replicationConfig.RESOLVE_TO_LOCAL);
        };

        replicationConfig.prototype.resolveAttachmentsConflictsToRemote = function () {
            this.attachmentConflictResolution(replicationConfig.RESOLVE_TO_REMOTE);
        };

        replicationConfig.prototype.doNotResolveAttachmentsConflictsAutomatically = function () {
            this.attachmentConflictResolution(replicationConfig.DO_NOT_RESOLVE_AUTOMATICALLY);
        };
        replicationConfig.DO_NOT_RESOLVE_AUTOMATICALLY = "None";
        replicationConfig.RESOLVE_TO_LOCAL = "ResolveToLocal";
        replicationConfig.RESOLVE_TO_REMOTE = "ResolveToRemote";
        return replicationConfig;
    })();

    
    return replicationConfig;
});
