define(["require", "exports", "models/replicationDestination"], function(require, exports, replicationDestination) {
    var replicationsSetup = (function () {
        function replicationsSetup(dto) {
            this.source = ko.observable();
            this.destinations = ko.observableArray().extend({ required: true });
            this.source(dto.Source);
            this.destinations(dto.Destinations.map(function (dest) {
                return new replicationDestination(dest);
            }));
        }
        replicationsSetup.prototype.toDto = function () {
            return {
                Destinations: this.destinations().map(function (dest) {
                    return dest.toDto();
                }),
                Source: this.source()
            };
        };
        return replicationsSetup;
    })();

    
    return replicationsSetup;
});
