var __extends = this.__extends || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    __.prototype = b.prototype;
    d.prototype = new __();
};
define(["require", "exports", "plugins/dialog", "commands/deleteCollectionCommand", "common/appUrl", "viewmodels/dialogViewModelBase"], function(require, exports, dialog, deleteCollectionCommand, appUrl, dialogViewModelBase) {
    var deleteCollection = (function (_super) {
        __extends(deleteCollection, _super);
        function deleteCollection(collection) {
            _super.call(this);
            this.collection = collection;
            this.deletionTask = $.Deferred();
            this.deletionStarted = false;
        }
        deleteCollection.prototype.deleteCollection = function () {
            var _this = this;
            var deleteCommand = new deleteCollectionCommand(this.collection.name, appUrl.getDatabase());
            var deleteCommandTask = deleteCommand.execute();
            deleteCommandTask.done(function () {
                return _this.deletionTask.resolve(_this.collection);
            });
            deleteCommandTask.fail(function (response) {
                return _this.deletionTask.reject(response);
            });
            this.deletionStarted = true;
            dialog.close(this);
        };

        deleteCollection.prototype.cancel = function () {
            dialog.close(this);
        };

        deleteCollection.prototype.deactivate = function () {
            if (!this.deletionStarted) {
                this.deletionTask.reject();
            }
        };
        return deleteCollection;
    })(dialogViewModelBase);

    
    return deleteCollection;
});
