var __extends = this.__extends || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    __.prototype = b.prototype;
    d.prototype = new __();
};
define(["require", "exports", "commands/deleteDatabaseCommand", "plugins/dialog", "common/appUrl", "viewmodels/dialogViewModelBase", "plugins/router"], function(require, exports, deleteDatabaseCommand, dialog, appUrl, dialogViewModelBase, router) {
    var deleteDatabaseConfirm = (function (_super) {
        __extends(deleteDatabaseConfirm, _super);
        function deleteDatabaseConfirm(dbToDelete, systemDb) {
            _super.call(this);
            this.dbToDelete = dbToDelete;
            this.systemDb = systemDb;
            this.isKeepingFiles = ko.observable(true);
            this.deleteTask = $.Deferred();

            if (!dbToDelete) {
                throw new Error("Must specified database to delete.");
            }

            if (!systemDb) {
                throw new Error("Must specify system database");
            }
        }
        deleteDatabaseConfirm.prototype.navigateToExportDatabase = function () {
            dialog.close(this);
            router.navigate(appUrl.forExportDatabase(this.dbToDelete));
        };

        deleteDatabaseConfirm.prototype.keepFiles = function () {
            this.isKeepingFiles(true);
        };

        deleteDatabaseConfirm.prototype.deleteEverything = function () {
            this.isKeepingFiles(false);
        };

        deleteDatabaseConfirm.prototype.deleteDatabase = function () {
            var _this = this;
            new deleteDatabaseCommand(this.dbToDelete.name, this.isKeepingFiles() === false, this.systemDb).execute().done(function (results) {
                return _this.deleteTask.resolve(results);
            }).fail(function (details) {
                return _this.deleteTask.reject(details);
            });

            dialog.close(this);
        };

        deleteDatabaseConfirm.prototype.cancel = function () {
            this.deleteTask.reject();
            dialog.close(this);
        };
        return deleteDatabaseConfirm;
    })(dialogViewModelBase);

    
    return deleteDatabaseConfirm;
});
