﻿var __extends = this.__extends || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    __.prototype = b.prototype;
    d.prototype = new __();
};
define(["require", "exports", "plugins/dialog", "commands/filesystem/deleteFileCommand", "common/appUrl", "viewmodels/dialogViewModelBase"], function(require, exports, dialog, deleteFileCommand, appUrl, dialogViewModelBase) {
    var deleteFiles = (function (_super) {
        __extends(deleteFiles, _super);
        function deleteFiles(files, elementToFocusOnDismissal) {
            _super.call(this, elementToFocusOnDismissal);
            this.files = ko.observableArray();
            this.deletionStarted = false;
            this.deletionTask = $.Deferred();

            if (files.length === 0) {
                throw new Error("Must have at least one file to delete.");
            }

            this.files(files);
        }
        deleteFiles.prototype.deleteFiles = function () {
            var _this = this;
            var deletedFilesIds = this.files().map(function (i) {
                return i.getId();
            });
            var deletionTasks = [];
            for (var i = 0; i < deletedFilesIds.length; i++) {
                var deleteCommand = new deleteFileCommand(appUrl.getFilesystem(), deletedFilesIds[i]);
                deletionTasks.push(deleteCommand.execute());
            }

            var combinedTask = $.when(deletionTasks);

            combinedTask.done(function () {
                return _this.deletionTask.resolve(_this.files());
            });
            combinedTask.fail(function (response) {
                return _this.deletionTask.reject(response);
            });

            this.deletionStarted = true;
            dialog.close(this);
        };

        deleteFiles.prototype.cancel = function () {
            dialog.close(this);
        };

        deleteFiles.prototype.deactivate = function (args) {
            if (!this.deletionStarted) {
                this.deletionTask.reject();
            }
        };
        return deleteFiles;
    })(dialogViewModelBase);

    
    return deleteFiles;
});
