﻿define(["require", "exports", "models/windowsAuthSetup", "models/windowsAuthData", "commands/getWindowsAuthCommand", "commands/saveWindowsAuthCommand"], function(require, exports, windowsAuthSetup, windowsAuthData, getWindowsAuthCommand, saveWindowsAuthCommand) {
    var windowsAuth = (function () {
        function windowsAuth() {
            this.setup = ko.observable();
        }
        windowsAuth.prototype.activate = function () {
            var _this = this;
            this.setup(new windowsAuthSetup({ RequiredUsers: [], RequiredGroups: [] }));

            new getWindowsAuthCommand().execute().done(function (result) {
                return _this.setup(result);
            });
        };

        windowsAuth.prototype.saveChanges = function () {
            new saveWindowsAuthCommand(this.setup().toDto()).execute();
        };

        windowsAuth.prototype.addUserSettings = function () {
            this.setup().requiredUsers.push(windowsAuthData.empty());
        };

        windowsAuth.prototype.removeUserSettings = function (data) {
            this.setup().requiredUsers.remove(data);
        };

        windowsAuth.prototype.addGroupSettings = function () {
            this.setup().requiredGroups.push(windowsAuthData.empty());
        };

        windowsAuth.prototype.removeGroupSettings = function (data) {
            this.setup().requiredGroups.remove(data);
        };
        return windowsAuth;
    })();

    
    return windowsAuth;
});
